/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package mcts;

import tictactoecodingame.Coup;
import tictactoecodingame.Joueur;

/**
 *
 * @author Lloyd
 */

public class Etat {
    
    int nbVisite;
    double scoreVictoire;
    int profondeur;
    Joueur joueur;
    Coup dernierCoup; //Le coup qui a mené à la création de ce noeud
    //Les 2 variables suivantes sont utilisées pour l'amélioration RAVE (Rapid Action Value Estimation), que je n'ai pas réussi à finir. 
    //Le principe est qu'à partir d'un noeud donné, 
    //le nombre de coup identique (et le nombre de coup identique gagnant) rencontrés lors des 4 phases du MCTS 
    //sont gardés en mémoire dans les noeuds enfant qui possèdent le même 'dernierCoup'.
    double scoreDernierCoup; //nombre de coup identique gagnant pour le parent (même principe de d'alternance entre parant et enfant que dans le MCTS classique
    int nbDernierCoup; //nombre de coup identique rencontrés lors de la phase du MCTS

    //CONSTRUCTEURS
    
    public Etat(int profondeur) {
        this.profondeur = profondeur;
    }
    
    public Etat() {
    }
    
    //GETTERS & SETTERS
    
    public int getNbVisite() {
        return nbVisite;
    }

    public void setNbVisite(int nbVisite) {
        this.nbVisite = nbVisite;
    }

    public double getScoreVictoire() {
        return scoreVictoire;
    }

    public void setScoreVictoire(double scoreVictoire) {
        this.scoreVictoire = scoreVictoire;
    }

    public int getProfondeur() {
        return profondeur;
    }

    public void setProfondeur(int profondeur) {
        this.profondeur = profondeur;
    }

    public Coup getDernierCoup() {
        return dernierCoup;
    }

    public void setDernierCoup(Coup dernierCoup) {
        this.dernierCoup = dernierCoup;
    }
    
    public Joueur getJoueur() {
        return joueur;
    }

    public void setJoueur(Joueur joueur) {
        this.joueur = joueur;
    }

    public double getScoreDernierCoup() {
        return scoreDernierCoup;
    }

    public void setScoreDernierCoup(double scoreDernierCoup) {
        this.scoreDernierCoup = scoreDernierCoup;
    }

    public int getNbDernierCoup() {
        return nbDernierCoup;
    }

    public void setNbDernierCoup(int nbDernierCoup) {
        this.nbDernierCoup = nbDernierCoup;
    }
    
    
    //MISE A JOUR DES SCORES ET DES NOMBRES DE VISITES
    
    public void updateNbVisite() {
        nbVisite++;
    }
    
    public void updateNbVictoire(double score) {
        scoreVictoire += score;
    }
    
    public void updateNbDernierCoup() {
        nbDernierCoup++;
    }
    
    public void updateScoreDernierCoup(double score) {
        scoreDernierCoup += score;
    }
    
}
